<%-- Kroly Pfaff - PFKIAAT.ELTE --%>
<%@ Page Language="C#" EnableSessionState="false" %>
<%@ Import Namespace="System" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<html>

<head>

  <!-- #Include File="include/header.inc" -->
  <!-- #Include File="include/base.inc" -->
  
  <script Language="C#" runat="server">

    int TotalQuestions = 14;
    int QuestionNumber = 1;
    int CorrectAnswer = 0;
    int TotalScore = 0;
    int QuizIterator = 0;


    public void Init_Values()
    {
        QuestionNumber = 1;
        CorrectAnswer = 0;
        TotalScore = 0;
        QuizIterator = 0;
        Store_Values();
    }

    public void Store_Values()
    {
        ViewState["QuestionNumber"] = QuestionNumber;
        ViewState["CorrectAnswer"] = CorrectAnswer;
        ViewState["TotalScore"] = TotalScore;
        ViewState["QuizIterator"] = QuizIterator;
    }
      
    public void Restore_Values()
    {
        QuestionNumber = (int)ViewState["QuestionNumber"];
        CorrectAnswer = (int)ViewState["CorrectAnswer"];
        TotalScore = (int)ViewState["TotalScore"];
        QuizIterator = (int)ViewState["QuizIterator"];
        errorMessage.Text = "";
    }

    public void Page_Load()
    {
        if (Page.IsPostBack)
        {
            Restore_Values();
        }
        else
        {
            Init_Values();
            Store_Values();
        }
    }


    private static string BuildConnectionString(string userName, string userPassword)
    {
        // Retrieve the partial connection string named databaseConnection
        // from the application's app.config or web.config file.
        ConnectionStringSettings settings = ConfigurationManager.ConnectionStrings["DatabaseConnection"];

        if (null != settings)
        {
            // Retrieve the partial connection string.
            string connectString = settings.ConnectionString;

            // Create a new SqlConnectionStringBuilder and set the User ID
            // and Password to the strings supplied as an input parameters.
            SqlConnectionStringBuilder builder = new SqlConnectionStringBuilder(connectString);
            builder.UserID = userName;
            builder.Password = userPassword;
            
            return builder.ConnectionString;
        }
        else return null;
    }


    public void Start_Click(Object sender, EventArgs e)
    { 
        // form authentication
        if (FormsAuthentication.Authenticate(UserName.Text, Password.Text))
        {
            Restart_Click(sender, e);
        }
        else
        {
            errorMessage.Text = "ERROR: You are not authenticated to play Quiz. You are sorry.";
        }
        // uses restart_click which is able to load the questions
    }
      

	public void Restart_Click(Object sender, EventArgs e)
	{
        try   // I must confess: I love error providing
        {
            using (SqlConnection myConnection = new SqlConnection(BuildConnectionString("teszt", "teszt")))
            {
                myConnection.Open();
                SqlDataAdapter myCommand = new SqlDataAdapter("" +
                    " SELECT	kerdes, valasz, helyes " +
                    " FROM	kerdesek, valaszok " +
                    " WHERE	kerdesek.sorszam IN " +
                        " ( " +
                            " SELECT	TOP (" + TotalQuestions + ") sorszam " +
                            " FROM	kerdesek " +
                    // " ORDER	BY NEWID() " +
                        " ) " +
                    " AND	kerdesek.sorszam = valaszok.kerdes_szam " +
                "", myConnection);

                // fill the DataSet
                DataSet myDataSet = new DataSet();
                myCommand.Fill(myDataSet);
                myConnection.Close();

                // add to dataset to non-visible mydatalist control 
                myDataList.DataSource = myDataSet;
                myDataList.DataBind();
            }

            // filling radiobuttons
            try
            {
                Fill_List(ref QuizIterator);
            }
            catch (Exception myException)
            {
                // fill list failed becouse of wrong fill of database
                errorMessage.Text = "ERROR: Something error occoured... we don't explain what we don't know. We are sorry.";
            }

            // visibility settings
            RestartButton.Visible = false;
            StartButton.Visible = false;
            NextButton.Visible = true;
            DescriptionPanel.Visible = true;
            DescriptionPicture.Visible = true;
            ResultPicture.Visible = false;
            ResultPanel.Visible = false;
            LogoutButton.Visible = true;
            NoLogoutButton.Visible = false;
            AuthenticationPanel.Visible = false;
            AfterGamePanel.Visible = false;
            QuizPanel.Visible = true;
            NameLabel.Text = UserName.Text.ToUpper();

            Store_Values();

        }
        catch (Exception myException)
        {
            // error handling
            errorMessage.Text = "ERROR: Database is unreachable. Or it is bad. Or we were bad. We are sorry.";
        }
	}
	// end of (re)start function


	public void Next_Click(Object sender, EventArgs e)
	{
        if ( AnswerList.SelectedIndex == CorrectAnswer )
        {
            TotalScore++;
        }
        
        // generate next question
        if ( QuestionNumber < TotalQuestions )
        {
            QuestionNumber++;
            try
            {
                Fill_List(ref QuizIterator);
            }
            catch ( Exception myException )
            {
                // filling list failed because of wrong fill of database
                errorMessage.Text = "ERROR: Something error occoured... we don't explain what we don't know. We are sorry.";
            }
            Store_Values();
        }
        else
        {
            try
            {
                using (SqlConnection myConnection = new SqlConnection(BuildConnectionString("teszt", "teszt")))
                {
                    myConnection.Open();

                    // write score into resulttable

                    // first we must read the latest index
                    SqlCommand GetNumber = new SqlCommand("" +
                        " SELECT max(sorszam) FROM eredmeny " +
                    "", myConnection);
                    Int32 NextNumber = System.Convert.ToInt32(GetNumber.ExecuteScalar()) + 1;

                    // and then insert important datas into database
                    SqlCommand InsertCommand = new SqlCommand("" +
                        " INSERT INTO [vetelkedo].[dbo].[eredmeny] " +
                        "       ([sorszam] " +
                        "       ,[nev] " +
                        "       ,[idopont] " +
                        "       ,[eredmeny]) " +
                        " VALUES " +
                        "       ( " +
                        "              " + NextNumber +
                        "           , '" + NameLabel.Text.ToLower() + "'" +
                        "           ,      GETDATE() " +
                        "           ,  " + TotalScore +
                        "       )" +
                    "", myConnection);
                    // datetime conversation...
                    InsertCommand.ExecuteNonQuery();


                    // get the top 10 results
                    SqlDataAdapter myCommand = new SqlDataAdapter("" +
                        " SELECT TOP (8)	nev, eredmeny " +
                        " FROM				eredmeny " +
                        " ORDER BY			eredmeny DESC " +
                    "", myConnection);

                    // fill the DataSet
                    DataSet myDataSet = new DataSet();
                    myCommand.Fill(myDataSet);
                    myConnection.Close();

                    // add to dataset to resultpanel's datagrid
                    ResultList.DataSource = myDataSet;
                    ResultList.DataBind();

                    myConnection.Close();
                }
            }
            catch
            {
                // filling list or inserting new result into database failed 
                errorMessage.Text = "ERROR: Something database error occoured... Something with writing... or reading... We are sorry.";
            }
            End_Game();
        }
	}
	// end of next function


    public void Fill_List ( ref int row )
    {
        if ( myDataList.Items.Count > row )
        {
            AnswerList.Items.Clear();
            string myValues = myDataList.Items[row].Cells[0].Text.ToString();
            QuestionLabel.Text = myValues;
            int CountAnswers = 0;
            while (myDataList.Items.Count > row && myDataList.Items[row].Cells[0].Text.ToString() == myValues)
            {
                AnswerList.Items.Add(new ListItem(myDataList.Items[row].Cells[1].Text.ToString()));
                if ( myDataList.Items[row].Cells[2].Text.ToString() == "True" )
                {
                    CorrectAnswer = CountAnswers;
                }
                row++;
                CountAnswers++;
            }
            QuizIterator = row;
        }
        else
        {
            throw new System.ArgumentOutOfRangeException();
        }
    }


    public void End_Game()
    {
        // visibility settings
        NextButton.Visible = false;
        StartButton.Visible = false;
        RestartButton.Visible = true;
        DescriptionPanel.Visible = false;
        DescriptionPicture.Visible = false;
        QuizPanel.Visible = false;
        ResultLabel.Text = TotalScore.ToString();
        AfterGamePanel.Visible = true;
        ResultPicture.Visible = true;
        ResultPanel.Visible = true;
        Init_Values();
    }
    // end of End_Game function


    public void Logout_Click(Object sender, EventArgs e)
    {
        // visibility settings
        NextButton.Visible = false;
        RestartButton.Visible = false;
        StartButton.Visible = true;
        ResultPanel.Visible = false;
        ResultPicture.Visible = false;
        DescriptionPicture.Visible = true;
        DescriptionPanel.Visible = true;
        LogoutButton.Visible = false;
        NoLogoutButton.Visible = true;
        AuthenticationPanel.Visible = true;
        QuizPanel.Visible = false;
        AfterGamePanel.Visible = false;
        NameLabel.Text = "";
    }
    // end of Logout_Click function

  </script>
  <%-- after submit script --%>


</head>

<body bgcolor="#ffffff">

<form name="QuizForm" ID="QuizForm" enctype="multipart/form-data" runat="server">

<!-- #Include File="include/top.inc" -->

  <tr>
   <td rowspan="14" colspan="2"><img name="quiz58" src="images/quiz58.jpg" width="14" height="212" border="0" alt=""></td>
   <td rowspan="2" colspan="6">
     <asp:Panel ID="DescriptionPicture" Width="98" Height="14" Visible="true" runat="server">
        <img name="rules" src="images/rules.jpg" width="98" height="14" border="0" alt="GAME RULES">
     </asp:Panel>
     <asp:Panel ID="ResultPicture" Width="98" Height="14" Visible="false" runat="server">
        <img name="rules" src="images/rulesf2.jpg" width="98" height="14" border="0" alt="BEST RESULTS">
     </asp:Panel>
   </td>
   <td rowspan="4"><img name="quiz60" src="images/quiz60.jpg" width="9" height="28" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="5" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="15"><img name="quiz61" src="images/quiz61.jpg" width="22" height="241" border="0" alt=""></td>
   <td rowspan="8" colspan="5"><img name="member" src="images/member.jpg" width="59" height="56" border="0" alt=""></td>
   <td rowspan="2" colspan="6"><img name="quiz63" src="images/quiz63.jpg" width="146" height="15" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="9" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="2" colspan="6"><img name="quiz64" src="images/quiz64.jpg" width="98" height="14" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="6" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="7"><img name="quiz65" src="images/quiz65.jpg" width="20" height="48" border="0" alt=""></td>
   <td rowspan="2" colspan="8"><img name="giveyourname" src="images/giveyourname.jpg" width="154" height="14" border="0" alt="PLEASE GIVE YOUR NAME"></td>
   <td rowspan="3" colspan="2"><img name="quiz67" src="images/quiz67.jpg" width="11" height="25" border="0" alt=""></td>
   <td rowspan="2" colspan="7" background="images/name.jpg" width="128" height="14" class="formtable">
     <%-- name comes here --%>
     <b><asp:Label ID="NameLabel" Width="120" Text="" CssClass="formtable" runat="server" /></b>
     <%-- end of name --%>
   </td>
   <td rowspan="7" colspan="2"><img name="quiz69" src="images/quiz69.jpg" width="8" height="48" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="8" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="7" colspan="10" width="188" height="132">
     <%-- panel for descriptions --%>
     <asp:Panel ID="DescriptionPanel" Width="188" Height="132" Visible="true" runat="server">
       <asp:Image ID="Description" ImageUrl="images/description.jpg" Width="188" Height="132" runat="server" />
     </asp:Panel>
     <%-- end of descriptions panel --%>
     <%-- panel for results --%>
     <asp:Panel ID="ResultPanel" Width="188" Height="132" BackImageUrl="images/descriptionf2.jpg" Visible="false" runat="server">
       <asp:DataGrid ID="ResultList" Width="188" Height="132" style="" Visible="true" ShowHeader="false" CssClass="resultitems" AutoGenerateColumns="False" runat="server">
         <Columns>
           <asp:BoundColumn DataField="nev" ReadOnly="True" ItemStyle-CssClass="resultitems" />
           <asp:BoundColumn DataField="eredmeny" ReadOnly="True" ItemStyle-CssClass="resultitems" />
         </Columns>
       </asp:DataGrid>
     </asp:Panel>
     <%-- end of results panel --%>
   </td>
   <td><img src="images/spacer.gif" width="1" height="6" border="0" alt=""></td>
  </tr>
  <tr>
   <td colspan="8"><img name="quiz71" src="images/quiz71.jpg" width="154" height="11" border="0" alt=""></td>
   <td colspan="7"><img name="quiz72" src="images/quiz72.jpg" width="128" height="11" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="11" border="0" alt=""></td>
  </tr>
  <tr>
   <td colspan="11"><img name="authenticate" src="images/authenticate.jpg" width="182" height="10" border="0" alt="AVAILABLE ONLY FOR AUTHENTICATED USERS"></td>
   <td rowspan="4" colspan="5"><img name="quiz74" src="images/quiz74.jpg" width="77" height="23" border="0" alt=""></td>
   <td rowspan="2">
     <%-- log out if visible or enabled --%>
     <asp:Image ID="NoLogoutButton" ImageUrl="images/logout.jpg" width="34" height="12" AlternateText="" Visible="true" runat="server" />
     <asp:ImageButton ID="LogoutButton" ImageUrl="images/logoutf2.jpg" width="34" height="12" AlternateText="LOG OUT" Visible="false" OnClick="Logout_Click" runat="server" />
     <%-- end of log out --%>
   </td>
   <td><img src="images/spacer.gif" width="1" height="10" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="3" colspan="11"><img name="quiz76" src="images/quiz76.jpg" width="182" height="13" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="2" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="2"><img name="quiz77" src="images/quiz77.jpg" width="34" height="11" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="4" border="0" alt=""></td>
  </tr>
  <tr>
   <td colspan="5"><img name="quiz78" src="images/quiz78.jpg" width="59" height="7" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="7" border="0" alt=""></td>
  </tr>
  <tr>
   <td colspan="25" background="images/quiz79.jpg" width="380" height="92">
     <%-- authentication comes here --%>
     <asp:Panel ID="AuthenticationPanel" Width="380" Height="92" Visible="true" runat="server">
       <br><br>
       <table border="0" cellpadding="0" cellspacing="0" align="right">
         <tr class="formtable">
           <td>
             <b>User name:</b>
             <asp:RequiredFieldValidator ControlToValidate="UserName" display="static" runat="server">
               <%-- required --%>*
             </asp:RequiredFieldValidator>
           </td>
           <td><asp:TextBox ID="UserName" MaxLength="25" runat="server" /></td>
         </tr>
         <tr class="formtable">
           <td>
             <b>Password:</b>
             <asp:RequiredFieldValidator ControlToValidate="Password" display="static" runat="server">
               <%-- required --%>*
             </asp:RequiredFieldValidator>
           </td>
           <td><asp:TextBox ID="Password" MaxLength="25" TextMode="Password" runat="server" /></td>
         </tr>
       </table>       
     </asp:Panel>
     <%-- end of authentication panel --%>
     <%-- questions and possible answers come here --%>
     <asp:Panel ID="QuizPanel" Width="380" Height="92" Visible="false" runat="server">
       <br><br>
       <b><asp:Label ID="QuestionLabel" Text="" CssClass="question" runat="server" /></b>
       <br>
       <asp:DropDownList ID="AnswerList" CssClass="dropdownlist" runat="server" />
     </asp:Panel>
     <%-- end of questions panel --%>
     <%-- after game panel comes here --%>
     <asp:Panel ID="AfterGamePanel" Width="380" Height="92" Visible="false" runat="server">
       <br><b>
       <span class="question">Your score is: </span>
       <asp:Label ID="ResultLabel" CssClass="question" Text="" runat="server" />
       </b><br>
       The best results you can watch on the right.
       You can start a new quiz clicking on start button, or you can leave using log out.
     </asp:Panel>
     <%-- end of after game panel panel --%>
   </td>
   <td><img src="images/spacer.gif" width="1" height="92" border="0" alt=""></td>
  </tr>
  <tr>
   <td colspan="27"><img name="quiz80" src="images/quiz80.jpg" width="398" height="7" border="0" alt=""></td>
   <td rowspan="3" colspan="10"><img name="quiz81" src="images/quiz81.jpg" width="188" height="52" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="7" border="0" alt=""></td>
  </tr>
  <tr>
   <td rowspan="2" colspan="21"><img name="quiz82" src="images/quiz82.jpg" width="286" height="45" border="0" alt=""></td>
   <td colspan="3">
     <%-- Start, restart and Next buttons place --%>
     <asp:ImageButton ID="StartButton" ImageUrl="images/button.jpg" Width="92" Height="23" BorderWidth="0" AlternateText="START" CssClass="aspImage" OnClick="Start_Click" Visible="true" runat="server" />
     <asp:ImageButton ID="RestartButton" ImageUrl="images/button.jpg" Width="92" Height="23" BorderWidth="0" AlternateText="START" CssClass="aspImage" OnClick="Restart_Click" Visible="false" runat="server" />
     <asp:ImageButton ID="NextButton" ImageUrl="images/buttonf2.jpg" Width="92" Height="23" BorderWidth="0" AlternateText="NEXT" OnClick="Next_Click" Visible="false" runat="server" />
     <%-- end of Start and Next buttons place --%>
   </td>
   <td rowspan="2" colspan="3"><img name="quiz84" src="images/quiz84.jpg" width="20" height="45" border="0" alt=""></td>
   <td><img src="images/spacer.gif" width="1" height="23" border="0" alt=""></td>
  </tr>
  
<!-- #Include File="include/bottom.inc" -->

<div style="text-align: center">
  <asp:label id="errorMessage" text="" style="color:#FF0000" runat="server" />
</div>

<asp:DataGrid ID="myDataList" Visible="false" runat="server">
</asp:DataGrid>

</form>
</body>
</html>
